#ifndef ROSA_BENCH_GRASPELS_DECL_H
#define ROSA_BENCH_GRASPELS_DECL_H

#include "common.h"

tsp::Solution none(tsp::Problem const&, RNG&, Arguments const&);

tsp::Solution hwElsGen(tsp::Solution const&, RNG&, Arguments const&);
tsp::Solution hw_seq(tsp::Problem const&, RNG&, Arguments const&);
tsp::Solution hw_par(tsp::Problem const&, RNG&, Arguments const&);

tsp::Solution hw_seq_v(tsp::Problem const&, RNG&, Arguments const&);
tsp::Solution hw_par_v(tsp::Problem const&, RNG&, Arguments const&);

tsp::Solution sk_nr_seq(tsp::Problem const&, RNG&, Arguments const&);
tsp::Solution sk_nr_par(tsp::Problem const&, RNG&, Arguments const&);

tsp::Solution sk_seq(tsp::Problem const&, RNG&, Arguments const&);
tsp::Solution sk_par_firstlevel(tsp::Problem const&, RNG&, Arguments const&);
tsp::Solution sk_par_staticpool(tsp::Problem const&, RNG&, Arguments const&);
tsp::Solution sk_par_dynamicpool(tsp::Problem const&, RNG&, Arguments const&);
tsp::Solution sk_par_thread(tsp::Problem const&, RNG&, Arguments const&);

tsp::Solution tbb_par(tsp::Problem const&, RNG&, Arguments const&);

#endif
