#ifndef MUSCLES_GRASP_H
#define MUSCLES_GRASP_H

#include <random>

struct Grasp {
	template<typename Solution, typename Problem>
	Solution operator()(Problem const&problem, std::size_t n) {
		Solution solution;

		std::mt19937 gen{0};

		for(std::size_t i = 0; i < n; ++i) {
			Solution const&initial{rgreedy(problem, gen)};
			Solution const&current{initial};
			if(current.value() < solution.value())
				solution = current;
		}

		return solution;
	}
};

#endif
