#ifndef MUSCLES_MOVE2OPT_H
#define MUSCLES_MOVE2OPT_H

#include <random>

struct Move2Opt {
	template<typename Solution, typename RandomEngine>
	Solution operator()(Solution const&initial, RandomEngine &gen) const {
		Solution solution = initial;
		std::size_t const size = solution.size();

		if(size > 3) {
			std::uniform_int_distribution<std::size_t> distE0{1, size-2};
			std::size_t e0 = distE0(gen);

			std::uniform_int_distribution<std::size_t> distB1{e0+1, e0 == 1? size-2:size-1};
			std::size_t b1 = distB1(gen);

			solution.move2Opt(e0, b1);
		}

		return solution;
	}
};

#endif
