#ifndef MUSCLES_MUTATESWAP_H
#define MUSCLES_MUTATESWAP_H

#include <random>

struct MutateSwap {
	template<typename Solution, typename RandomEngine>
	Solution operator()(Solution const&initial, RandomEngine &gen) const {
		Solution solution = initial;
		std::size_t const size = solution.size();

		if(size > 1) {
			std::uniform_int_distribution<std::size_t> dist{0, size-1};

			std::size_t i = dist(gen), j;
			do j = dist(gen); while(i == j);

			solution.swap(i, j);
		}

		return solution;
	}
};

#endif
