#include "problem.h"

namespace tsp {

Problem::Problem(Points const&points):
	points{points},
	distances(points.size())
{
	std::size_t const size = points.size();
	for(std::size_t i = 0; i < size-1; ++i) {
		Point const&pi = points[i];

		for(std::size_t j = i+1; j < size; ++j) {
			Point const&pj = points[j];
			Distance dx = pj.x-pi.x, dy = pj.y-pi.y;
			Distance d = std::sqrt(dx*dx + dy*dy);

			distances(i, j) = d;
			distances(j, i) = d;
		}
	}
}

}
