#include <fstream>
#include <iostream>
#include <limits>
#include <sstream>

#include "tsp.h"

namespace tsp {

Tsp::Tsp(std::string const&filename) {
	std::ifstream s{filename};
	if(!s.is_open()) throw std::runtime_error{"cannot open '"+filename+"'"};

	for(std::string line; std::getline(s, line); ) {
		std::istringstream iss{line};
		std::string word;

		iss >> word;
		while(std::isblank(iss.peek()) || std::ispunct(iss.peek())) iss.get();
		if(word.substr(0, 4) == "NAME") {
			iss >> _name;
		} else if(word.substr(0, 9) == "DIMENSION") {
			iss >> _dim;
		} else if(word == "NODE_COORD_SECTION") {
			break;
		}
	}

	std::size_t i = 0;
	for(std::string line; i < _dim && std::getline(s, line); ++i) {
		std::istringstream iss{line};
		double x, y;
		iss >> x >> x >> y;
		_points.emplace_back(x, y);
	}
}

}
