#ifndef TSP_TYPES_H
#define TSP_TYPES_H

#include <cmath>
#include <vector>

namespace tsp {

using Coord     = double;
using Distance  = double;

class DistanceMatrix {
	std::size_t _size;
	std::vector<Distance> _distances;

public:
	DistanceMatrix(std::size_t size): _size{size}, _distances(size*size, Distance{0}) {}

	Distance &operator()(std::size_t i, std::size_t j) { return _distances[i*_size+j]; }
	Distance const&operator()(std::size_t i, std::size_t j) const { return _distances[i*_size+j]; }
};

}

#endif
